/************************************************************************/
/*  Copyright (c) 1997-2000 Nalante, Inc., 245 Falconer End, Edmonton,  */
/*  Alberta, Canada, T6R 2V6, Phone: (780) 432-5288, Fax: (780) 988-0184*/
/*  All Rights Reserved                                                 */
/*                                                                      */
/*  THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF Nalante, Inc.        */
/*  The copyright notice above does not evidence any                    */
/*  actual or intended publication of such source code.                 */
/*                                                                      */
/*  Unauthorized copy or distribution of this file is prohibited.       */
/************************************************************************/



#ifndef ENT_H
#define ENT_H

#ifndef CONFIG_H
#include "config.h"
#endif

typedef void* Ent;

typedef void (*OneArgProc)(Ent);
typedef void (*TwoArgProc)(Ent, Ent);
typedef void (*ThreeArgProc)(Ent, Ent, Ent);
typedef int (*OneArgPred)(Ent);
typedef int (*TwoArgPred)(Ent, Ent);
typedef int (*ThreeArgPred)(Ent, Ent, Ent);
typedef Ent (*OneArgFunc)(Ent);
typedef Ent (*TwoArgFunc)(Ent, Ent);
typedef Ent (*ThreeArgFunc)(Ent, Ent, Ent);
typedef Ent (*FourArgFunc)(Ent, Ent, Ent, Ent);
typedef Ent (*FiveArgFunc)(Ent, Ent, Ent, Ent, Ent);
typedef Ent (*EntPrinter)(Ent, ostream&);

extern int cmp_ent(const Ent, const Ent);
extern int ent_eq(const Ent, const Ent);

inline Ent unify_ent(Ent x, Ent y)
{
  if (x) return x;
  else return y;
}

#endif
