/************************************************************************/
/*  Copyright (c) 1997-2000 Nalante, Inc., 245 Falconer End, Edmonton,  */
/*  Alberta, Canada, T6R 2V6, Phone: (780) 432-5288, Fax: (780) 988-0184*/
/*  All Rights Reserved                                                 */
/*                                                                      */
/*  THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF Nalante, Inc.        */
/*  The copyright notice above does not evidence any                    */
/*  actual or intended publication of such source code.                 */
/*                                                                      */
/*  Unauthorized copy or distribution of this file is prohibited.       */
/************************************************************************/



#ifndef RSTREE_H
#define RSTREE_H

#ifndef TRSLIST_H
#include "trslist.h"
#endif

////                    CLASS RSTree
////
////    An RSlist implemented RSTree. There is not much difference
////    from RSlist except each node has a point to a data
////    value.

class CLASS_DECLSPEC RSTree : public TRSlist<RSTree*> {
protected:
  RSTree* _parent;
public:
  RSTree* insert_in_front(RSTree* tobe_inserted);
  RSTree* insert_after(RSTree* tobe_inserted);
  RSTree* parent() { return _parent;}
  int level() const;
  void parent(RSTree* parent) { _parent = parent;}
  int decendent_of(RSTree* ancestor);
  int ancestor_of(RSTree* decendent);
  void insert(RSTree* l);
  void append(RSTree* l);
  RSTree* del();
  RSTree* get(int i) { return (RSTree*) RSlist::get(i);}
  Ent ord_insert(RSTree* a, int (*cmp)(RSTree*, RSTree*), int no_dup = 0);
  RSTree* get() {
    RSTree* first = (RSTree*) RSlist::get();
    if (first) first->parent(0);
    return first;
  }
  RSTree* first() { return (RSTree*) RSlist::first();}
  RSTree* last() { return (RSTree*) RSlist::last();}
  RSTree* root() const;
//  virtual RSTree* dup_root() const;
//  virtual ostream& print(ostream& strm, int spaces = 0);
//  virtual ostream& print_root(ostream& strm) const;
  RSTree() { _parent = 0;}
//  virtual ~RSTree();
};

#endif /* RSTREE_H */
