/************************************************************************/
/*  Copyright (c) 1997-2000 Nalante, Inc., 245 Falconer End, Edmonton,  */
/*  Alberta, Canada, T6R 2V6, Phone: (780) 432-5288, Fax: (780) 988-0184*/
/*  All Rights Reserved                                                 */
/*                                                                      */
/*  THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF Nalante, Inc.        */
/*  The copyright notice above does not evidence any                    */
/*  actual or intended publication of such source code.                 */
/*                                                                      */
/*  Unauthorized copy or distribution of this file is prohibited.       */
/************************************************************************/



#ifndef TRSLIST_H
#define TRSLIST_H

#ifndef TSLIST_H
#include "tslist.h"
#endif

#ifndef RSLIST_H
#include "rslist.h"
#endif

template<class CLASS_DECLSPEC Type> class TRSlist : public RSlist {
public:
  Type ord_insert(const Type a, int (*cmp)(Type,Type), int no_dup = 0) {
    return (Type) Slist::ord_insert((Ent) a, (TwoArgPred) cmp, no_dup);
  }
  Type ord_search(const Type a, int (*cmp)(Type, Type), Slink*& place) {
    return (Type) Slist::ord_search((Ent) a, (TwoArgPred) cmp, place);
  }
  Type ord_del(const Type a, int (*cmp)(Type, Type)) {
    return (Type) Slist::ord_del((Ent) a, (TwoArgPred) cmp);
  }
  void append_list(TRSlist<Type>& list) {RSlist::append_list(list);}
  Type get() {return (Type) RSlist::get();}
  Type get(int i) const { return (Type) RSlist::get(i);}
  Type replace(int i, Type l) {
    return (Type) RSlist::replace(i, l);
  }
  Type del(Type l) { return (Type) RSlist::del(l);}
  Type search(Type l) { return (Type) RSlist::search(l);}
  Type search(const Ent arg, int (*pred)(Type, Type), int neg=0) const {
    return (Type) RSlist::search(arg, (TwoArgPred) pred, neg);
  }
  Type top() const { return (Type) RSlist::top();}
  Type first() const { return (Type) RSlist::first();}
  Type last() { return (Type) RSlist::last();}
  Type reduce(Type seed, Type (*func)(Type, Type)) {
    return (Type) RSlist::reduce(seed, (TwoArgFunc) func);
  }
  TRSlist() {}
};

template<class CLASS_DECLSPEC Type> class TRSlistIterator : public TSlistIterator<Type> {
public:
  TRSlistIterator(const TRSlist<Type>* list) 
    : TSlistIterator<Type>((const TSlist<Type>*) list) {}
  TRSlistIterator(const TRSlist<Type>& list) 
    : TSlistIterator<Type>((const TSlist<Type>&) list) {}
};

template<class CLASS_DECLSPEC Type> class TPreIterator : public PreIterator {
public:
  Type parent() { return (Type) RSlistIterator::parent();}
  TPreIterator(const Type slist) : PreIterator((RSlist*) slist) {}
  Type current() { return (Type) PreIterator::current();}
  Type next() { return (Type) PreIterator::next();}
  Type skip() { return (Type) PreIterator::skip();}
  Type del_current() { 
    return (Type) PreIterator::del_current();
  }
  Type del_parent(int level=1) {
    return (Type) PreIterator::del_parent(level);
  }
};

template<class CLASS_DECLSPEC Type> class TPostIterator : public PostIterator {
public:
  TPostIterator(const Type slist) : PostIterator((RSlist*) slist) {}
  Type current() { return (Type) PostIterator::current();}
  Type next() { return (Type) PostIterator::next();}
  Type skip() { return (Type) PostIterator::skip();}
  Type del_current() { 
    return (Type) PostIterator::del_current();
  }
  Type del_parent(int level=1) {
    return (Type) PostIterator::del_parent(level);
  }
};

template<class CLASS_DECLSPEC Type> class TBreadthIterator : public BreadthIterator {
public:
  TBreadthIterator(const Type slist) : BreadthIterator((RSlist*) slist) {}
  Type current() { return (Type) BreadthIterator::current();}
  Type next() { return (Type) BreadthIterator::next();}
  Type skip() { return (Type) BreadthIterator::skip();}
  Type del_current() { 
    return (Type) BreadthIterator::del_current();
  }
};

#endif /* TRSLIST_H */
