/************************************************************************/
/*  Copyright (c) 1997-2000 Nalante, Inc., 245 Falconer End, Edmonton,  */
/*  Alberta, Canada, T6R 2V6, Phone: (780) 432-5288, Fax: (780) 988-0184*/
/*  All Rights Reserved                                                 */
/*                                                                      */
/*  THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF Nalante, Inc.        */
/*  The copyright notice above does not evidence any                    */
/*  actual or intended publication of such source code.                 */
/*                                                                      */
/*  Unauthorized copy or distribution of this file is prohibited.       */
/************************************************************************/



#ifndef TRSTREE_H
#define TRSTREE_H

#ifndef RSTREE_H
#include "rstree.h"
#endif

template<class CLASS_DECLSPEC Type> class TRSTree :  public RSTree {
public:
  Type insert_in_front(Type tobe_inserted) {
    return (Type) RSTree::insert_in_front((RSTree*) tobe_inserted);
  }
  Type insert_after(Type tobe_inserted) {
    return (Type) RSTree::insert_after((RSTree*) tobe_inserted);
  }
  Type parent() { return (Type) RSTree::parent();}
  Type root() { return (Type) RSTree::root();}
  void parent(Type parent) { RSTree::parent((RSTree*) parent);}
  int decendent_of(Type ancestor) {
    return RSTree::decendent_of((RSTree*) ancestor);
  }
  int ancestor_of(Type decendent) { 
    return RSTree::ancestor_of((RSTree*) decendent);
  }
  void insert(Type l) { RSTree::insert((RSTree*) l);}
  void append(Type l) { RSTree::append((RSTree*) l);}
  Type del() { return (Type) RSTree::del();}
  Type get(int i) { return (Type) RSTree::get(i);}
  Type ord_insert(Type a, int (*cmp)(Type,Type), int no_dup = 0) {
    return (Type) RSTree::ord_insert(a, (int (*)(RSTree*, RSTree*)) cmp, no_dup);
  }
  Type get() { return (Type) RSTree::get();}
  Type first() { return (Type) RSTree::first();}
  Type last() { return (Type) RSTree::last();}
  TRSTree() {}
};

template<class CLASS_DECLSPEC Type> class TRSTreeIterator : public SlistIterator {
public:
  TRSTreeIterator(const TRSTree<Type>* list) 
    : SlistIterator(list) {}
  TRSTreeIterator(const TRSTree<Type>& list) 
    : SlistIterator(list) {}
  Type next() { return (Type) SlistIterator::next();}
  Type current() const { return (Type) SlistIterator::current();}
  Type del_current() { return (Type) SlistIterator::del_current();}
  void insert_before_current(Type x) {
    SlistIterator::insert_before_current(x);
  }
};

#endif /* RSTREE_H */
